package com.zksy.web.controller.basicData;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseLogistics;
import com.zksy.system.basicData.service.CrmEnterpriseLogisticsService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.MergeReadsExcelUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 企业物流信息Controller
 *
 * @author sy
 * @date 2024-09-27
 */
@RestController
@RequestMapping("/crmEnterpriseLogistics")
@Api(tags = "企业物流信息", description = "企业物流信息desc")
public class CrmEnterpriseLogisticsController extends BaseController{

    @Autowired
    private CrmEnterpriseLogisticsService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业物流信息搜索getById")
    public CrmEnterpriseLogistics getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业物流信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业物流信息查询所有")
    public List<CrmEnterpriseLogistics> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增企业物流信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业物流信息新增")
    @Log(title = "新增企业物流信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseLogistics crmEnterpriseLogistics) {
        return service.save(crmEnterpriseLogistics);
    }

    /**
     * 修改企业物流信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业物流信息修改")
    @Log(title = "修改企业物流信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseLogistics crmEnterpriseLogistics) {
        return service.updateById(crmEnterpriseLogistics);
    }

    /**
     * 导入企业物流信息
     */
    @ApiOperation("企业物流信息导入")
    @Log(title = "企业物流信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            //List<CrmEnterpriseLogistics> crmEnterpriseLogisticsAll = service.list();
            List<Map<String,String>> list = MergeReadsExcelUtil.readExcelToObj(file, CrmEnterpriseLogistics.class.getDeclaredFields().length - 2,1,1,CrmEnterpriseLogistics.class);
            List<CrmEnterpriseLogistics> crmEnterpriseLogistics= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmEnterpriseLogistics>>() {});
            //if(crmEnterpriseLogisticsAll != null && crmEnterpriseLogisticsAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
           // }
            if(list.size() > 0){
                service.saveBatch(crmEnterpriseLogistics);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业物流信息导出")
    @Log(title = "企业物流信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseLogistics> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业物流信息",wrapperList,CrmEnterpriseLogistics.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业物流信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业物流信息", notes = "删除企业物流信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业物流信息模板");
    }
}

